
#import <OBJBRuntime/OBJBRuntime.h>

#import "Global.h"


Global *OBJB_sharedGlobalSingleton = nil;


@implementation Global

- (id) init
{
  if ((self = [super init])){
    [self Init];
  }
  return self;
}

- (void) finalize
{
  [super finalize];
}

- (void) awakeFromNib
{
  if (OBJB_sharedGlobalSingleton == nil) OBJB_sharedGlobalSingleton = self; //[self Init];
}

- (void) Init
{
}

- (void)sheetDidEnd:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
  [self OBJB_EndSheet: OBJB_ID(sheet): OBJB_ID(returnCode): OBJB_ID((NSString *) contextInfo)];
}

+ (Global *) sharedGlobal
{
  @synchronized(self){
    if (OBJB_sharedGlobalSingleton == nil) OBJB_sharedGlobalSingleton = [[Global alloc] init];
    return OBJB_sharedGlobalSingleton;
  }
}

- (void) OBJB_EndSheet: (NSWindow *) sheet: (id) returnCode: (NSString *) contextInfo
{
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "EndSheet", "18", "0");
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "EndSheet", "18", "1");
OBJB_MSGBOX(contextInfo, returnCode);
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "EndSheet", "19", "1");
OBJB_NSWINDOW_HIDE(sheet);
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "EndSheet", "20", "2");
}

- (IBAction) closeit: (id) sender
{
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "closeit", "11", "0");
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "closeit", "11", "1");
OBJB_ENDSHEET(thesheet, OBJB_ID((NSInteger) 12345));
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "closeit", "12", "2");
}

- (IBAction) showit: (id) sender
{
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "showit", "4", "0");
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "showit", "4", "1");
id i = (OBJB__INTEGER(OBJB_ID((NSInteger) 9000)));
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "showit", "5", "1");
OBJB_MSGBOX(i, OBJB_IDNIL());
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "showit", "7", "1");
OBJB_BEGINSHEET(self, thesheet, OBJB_ID(@"mycontext"));
                                                                  /*DEBUG*/OBJBS("Global.NSObject.objb", "showit", "8", "2");
}


@end


id OBJB_GLOBAL_INIT(id object, const char *Name_OnAction)

{
    id aGlobal = [[Global alloc] init];
    if ([object respondsToSelector:sel_registerName(Name_OnAction)]){
        [aGlobal setAction:sel_registerName(Name_OnAction)];
        [aGlobal setTarget:object];
    }
    return aGlobal;
}

id OBJB__GLOBAL(id m)

{

    if (m == nil || [m isKindOfClass:[Global class]]){

        return m;

    }

    OBJB_EXCEPTION(OBCastException, @"'Global' expected", [m description]);

    return nil;

}
@implementation OBJB_Application
- (void)reportException:(NSException *)anException
{
  NSString *s = [[NSString alloc] initWithFormat: @"\n\nException in\n file '%@'\n at '%@'\n line '%@'\n\ncallStackSymbols:\n%@", ObjBF(), ObjBS(), ObjBL(), [[anException callStackSymbols] description]];
  NSLog(@"%@", s);
  OBJB_MSGBOX(OBJB_ADD(@"Exception ", [anException name]), OBJB_ADD(OBJB_ADD([anException reason], [anException userInfo] == nil ? @"" : OBJB_ADD(@"\n\n", [anException userInfo])), s));
}
@end

int main (int argc, char *argv[])
{
  [OBJB_Application sharedApplication];
  return NSApplicationMain(argc,  (const char **) argv);
}

